/* UNIX V compiler setup */

#include <fcntl.h>
#define BUPDATE O_RDWR
#define BCREATE 0666
#define C255	-1
#define ct_NULL	0L
#define remove	unlink

/*
 * MAKE SURE THAT ct_NULL is properliy sized for your system and compiler
 * memory model.  Most 32 bit systems use 4 byte pointers; hence, ct_NULL
 * should be a 4 byte null value (0L). However, the 80286/80386 family usually
 * require a ct_NULL which can change with the memory model. Hence ct_NULL
 * can be defined as (char *) 0. Run CTTEST to check out your setup.
 *
 * MAKE SURE THAT cpybuf IS defined CORRECTLY: cpybuf does a straight n byte 
 * copy. It does not stop on NULL bytes.
 *
 * Be sure that the CTOPTN.H file contains the correct HIGH_LOW / LOW_HIGH
 * setting.  If there are any questions, compile and execute CTTEST.C.
 * 
 * You may eliminate the following cpybuf #define. c-tree will then 
 * automatically use a C source code version of cpybuf found in CTCLB2.C.
 */

#define cpybuf(dest_ptr,source_ptr,n) memcpy(dest_ptr,source_ptr,n)

